<?php
/**
 *
 * @package	    Pay My Bill Module
 * @subpackage	Pay My Bill Module
 * @version     1.0.0
 * @description Pay My Bill Module
 * @copyright	  Copyright © 2015 - All rights reserved.
 * @license		  GNU General Public License v2.0
 * @author		  SoftPill.Eu
 * @author mail	mail@softpill.eu
 * @website		  www.softpill.eu
 *
 */
//ini_set("display_errors",0);
//error_reporting(E_ALL);

if (version_compare(PHP_VERSION, '5.3.1', '<'))
{
	die('Your host needs to use PHP 5.3.1 or higher to run this version of Joomla!');
}
define('_JEXEC', 1);
define('DS', DIRECTORY_SEPARATOR);
defined( '_JEXEC' ) or die( 'Restricted access' );
$dirname=str_ireplace(DS.'modules'.DS.'mod_paymybill'.DS.'methods'.DS.'vendor','', dirname(__FILE__));

if (file_exists($dirname.DS.'defines.php'))
{
	include_once $dirname.DS.'defines.php';
}
if (!defined('_JDEFINES'))
{
	define('JPATH_BASE', $dirname);
	require_once JPATH_BASE.DS.'includes/defines.php';
}
require_once JPATH_BASE.DS.'includes/framework.php';
// Mark afterLoad in the profiler.
JDEBUG ? $_PROFILER->mark('afterLoad') : null;
// Instantiate the application.
$app = JFactory::getApplication('site');

$lang = JFactory::getLanguage();
$extension = 'mod_paymybill';
$language_tag = $lang->getTag();
$reload = true;
$lang->load($extension, $dirname, $language_tag, $reload);


require JPATH_BASE.'/modules/mod_paymybill/methods/vendor/autoload.php';
use net\authorize\api\contract\v1 as AnetAPI;
use net\authorize\api\controller as AnetController;
define("AUTHORIZENET_LOG_FILE", "phplog");

$action=isset($_POST['action'])?$_POST['action']:"";

require_once(JPATH_BASE.DS."modules".DS."mod_paymybill".DS."helper.php");
$PMBHelper = new PMBHelper();

$session_id=isset($_POST['order_id'])?$_POST['order_id']:"";

if($session_id=="")
  exit;
$module_id=0;
$tarr=explode("-",$session_id);
$module_id=$tarr[1]+0;
if($module_id==0)
  exit;

$params=$PMBHelper->getWorkingModParams($module_id);

$method_name='Authorize.net';

require_once(JPATH_BASE.DS."modules".DS."mod_paymybill".DS."functions".DS."functions.php");
$pmbf=new PMBFunctions();
$details=$pmbf->getOrderDetails($session_id);

if($action=='cancel_transaction')
{
  //send mail
  if($params['mail_cancelled']!=0)
  {
    $pmbf->sendConfirmationMail('cancelled',$params,$details,$method_name);
  }
  $pmbf->setOrderCancelled($params,$details,$method_name);
}

if($action=='sucessful_transaction')
{
  $transId=isset($_POST['transId'])?$_POST['transId']:"";
  createCustomerProfileFromTransaction($transId,$params,$details);
  //send mail
  if($params['mail_success']!=0)
  {
    $pmbf->sendConfirmationMail('success',$params,$details,$method_name);
  }
  $pmbf->setOrderSuccess($params,$details,$method_name);
}
function createCustomerProfileFromTransaction($transId="0",$params=array(),$details=array())
{
    /* Create a merchantAuthenticationType object with authentication details
       retrieved from the constants file */
    $merchantAuthentication = new AnetAPI\MerchantAuthenticationType();
    $merchantAuthentication->setName($params["authorize_user"]);
    $merchantAuthentication->setTransactionKey($params["authorize_password"]);
    
    $customerProfile = new AnetAPI\CustomerProfileBaseType();
    $customerProfile->setMerchantCustomerId($details["id"]);
    $customerProfile->setEmail($details["BillEmail"]);
    $customerProfile->setDescription($details["BillFname"]." ".$details["BillLname"]);
      
    $request = new AnetAPI\CreateCustomerProfileFromTransactionRequest();
    $request->setMerchantAuthentication($merchantAuthentication);
    $request->setTransId($transId);

    // You can either specify the customer information in form of customerProfileBaseType object
    $request->setCustomer($customerProfile);
    //  OR   
    // You can just provide the customer Profile ID
        //$request->setCustomerProfileId("123343");

    $controller = new AnetController\CreateCustomerProfileFromTransactionController($request);
    
    if($params['authorize_mode']=='TEST')
      $response = $controller->executeWithApiResponse(\net\authorize\api\constants\ANetEnvironment::SANDBOX);
    else
      $response = $controller->executeWithApiResponse(\net\authorize\api\constants\ANetEnvironment::PRODUCTION);

    if (($response != null) && ($response->getMessages()->getResultCode() == "Ok")) {
        getCustomerProfileDetails($response->getCustomerProfileId(),$params,$details);
    } else {
        echo "1";exit;
    }
}
function getCustomerProfileDetails($profileIdRequested=0,$params=array(),$details=array())
{
    /* Create a merchantAuthenticationType object with authentication details
       retrieved from the constants file */
    $merchantAuthentication = new AnetAPI\MerchantAuthenticationType();
    $merchantAuthentication->setName($params["authorize_user"]);
    $merchantAuthentication->setTransactionKey($params["authorize_password"]);
    
	  // Retrieve an existing customer profile along with all the associated payment profiles and shipping addresses

	  $request = new AnetAPI\GetCustomerProfileRequest();
	  $request->setMerchantAuthentication($merchantAuthentication);
	  $request->setCustomerProfileId($profileIdRequested);
	  $controller = new AnetController\GetCustomerProfileController($request);
    if($params['authorize_mode']=='TEST')
	   $response = $controller->executeWithApiResponse( \net\authorize\api\constants\ANetEnvironment::SANDBOX);
    else
      $response = $controller->executeWithApiResponse( \net\authorize\api\constants\ANetEnvironment::PRODUCTION);
    
	  if (($response != null) && ($response->getMessages()->getResultCode() == "Ok") )
	  {
  		$profileSelected = $response->getProfile();
  		$paymentProfilesSelected = $profileSelected->getPaymentProfiles();
      $shipto = $profileSelected->getShipToList();
      if(!isset($paymentProfilesSelected[0]))
      {
        echo "3";exit;
      }
      if(!isset($shipto[0]))
      {
        echo "4";exit;
      }
      //echo "customer profile id: ".$profileIdRequested." payment profile id: ".$paymentProfilesSelected[0]->getCustomerPaymentProfileId();
      //echo " address id: ".$shipto[0]->getCustomerAddressId();
      if($params["recurring_value"]>0)
      {
        createSubscriptionFromCustomerProfile($params["recurring_value"], $params["recurring_unit"], $profileIdRequested,$paymentProfilesSelected[0]->getCustomerPaymentProfileId(), $shipto[0]->getCustomerAddressId(), $params, $details);
      }
      else
      {
        echo "00";exit;
      }
	  }
	  else
	  {
  		echo "2";exit;
	  }
}
function createSubscriptionFromCustomerProfile($intervalLength, $recurringunit, $customerProfileId,$customerPaymentProfileId, $customerAddressId, $params=array(), $details=array())
{
    /* Create a merchantAuthenticationType object with authentication details
       retrieved from the constants file */
    $merchantAuthentication = new AnetAPI\MerchantAuthenticationType();
    $merchantAuthentication->setName($params["authorize_user"]);
    $merchantAuthentication->setTransactionKey($params["authorize_password"]);
    
    $payment=$details['payment'];
    $payment=round($payment,2);
    
    // Set the transaction's refId
    $refId = $details["id"] . time();

    // Subscription Type Info
    $subscription = new AnetAPI\ARBSubscriptionType();
    $subscription->setName($params["product_name"]);

    $interval = new AnetAPI\PaymentScheduleType\IntervalAType();
    $interval->setLength($intervalLength);
    $interval->setUnit($recurringunit);

    $paymentSchedule = new AnetAPI\PaymentScheduleType();
    $paymentSchedule->setInterval($interval);
    //$paymentSchedule->setStartDate(new DateTime(date("Y-m-d",strtotime(date("Y-m-d")." +$intervalLength days"))));
    $paymentSchedule->setStartDate(new DateTime(date("Y-m-d")));
    $paymentSchedule->setTotalOccurrences("999");
    $paymentSchedule->setTrialOccurrences("1");

    $subscription->setPaymentSchedule($paymentSchedule);
    $subscription->setAmount($payment);
    $subscription->setTrialAmount("0.00");
    
    $profile = new AnetAPI\CustomerProfileIdType();
    $profile->setCustomerProfileId($customerProfileId);
    $profile->setCustomerPaymentProfileId($customerPaymentProfileId);
    $profile->setCustomerAddressId($customerAddressId);

    $subscription->setProfile($profile);

    $request = new AnetAPI\ARBCreateSubscriptionRequest();
    $request->setmerchantAuthentication($merchantAuthentication);
    $request->setRefId($refId);
    $request->setSubscription($subscription);
    $controller = new AnetController\ARBCreateSubscriptionController($request);
    
    if($params['authorize_mode']=='TEST')
      $response = $controller->executeWithApiResponse( \net\authorize\api\constants\ANetEnvironment::SANDBOX);
    else
      $response = $controller->executeWithApiResponse( \net\authorize\api\constants\ANetEnvironment::PRODUCTION);
    
    if (($response != null) && ($response->getMessages()->getResultCode() == "Ok") )
    {
        //echo "SUCCESS: Subscription ID : " . $response->getSubscriptionId() . "\n";
        echo "01";exit;
     }
    else
    {
        $errorMessages = $response->getMessages()->getMessage();
        echo $errorMessages[0]->getText();
    }

    return $response;
  }
?>